libcamera: libcamera::Object Class Reference

libcamera v0.7.0 Supporting cameras in Linux since 2019

Loading...
Searching...
No Matches
libcamera::Object Class Reference

Base object to support automatic signal disconnection. More...

Inheritance diagram for libcamera::Object:
[legend]

## Public Member Functions
| Object (Object *parent=nullptr)
| Construct an Object instance.
virtual | ~Object ()
| Destroy an Object instance.
void | deleteLater ()
| Schedule deletion of the instance in the thread it belongs to.
void | postMessage (std::unique_ptr< Message > msg)
| Post a message to the object's thread.
template<typename T, typename R, typename... FuncArgs, typename... Args, std::enable_if_t< std::is_base_of< Object, T >::value > * = nullptr>
R | invokeMethod (R(T::*func)(FuncArgs...), ConnectionType type, Args &&... args)
| Invoke a method asynchronously on an Object instance.
Thread * | thread () const
| Retrieve the thread the object is bound to.
void | moveToThread (Thread *thread)
| Move the object and all its children to a different thread.
Object * | parent () const
| Retrieve the object's parent.

## Protected Member Functions
virtual void | message (Message *msg)
| Message handler for the object.
bool | assertThreadBound (const char *message)
| Check if the caller complies with thread-bound constraints.

## Friends
class | SignalBase
class | Thread

## Detailed Description

Base object to support automatic signal disconnection.

The Object class simplifies signal/slot handling for classes implementing slots. By inheriting from Object, an object is automatically disconnected from all connected signals when it gets destroyed.

Object instances are bound to the thread of their parent, or the thread in which they're created when they have no parent. When a message is posted to an object, its handler will run in the object's thread. This allows implementing easy message passing between threads by inheriting from the Object class.

Deleting an object from a thread other than the one the object is bound to is unsafe, unless the caller ensures that the object's thread is stopped and no parent or child of the object gets deleted concurrently. See Object::~Object() for more information.

Object slots connected to signals will also run in the context of the object's thread, regardless of whether the signal is emitted in the same or in another thread.

Objects can be connected to multiple signals, but they can only be connected to each signal once. Attempting to create multiple concurrent connections between the same signal and the same Object (to either the same or differents slots of the object) will cause an assertion failure. While it would be possible to allow the implementation to let objects connect to the same signal multiple times, there are no expected use cases for this in libcamera and this behaviour is restricted to favour defensive programming.

See also
  Message, Signal, Thread

## Constructor & Destructor Documentation

## ◆ Object()

libcamera::Object::Object | ( | Object * | parent = nullptr | ) |

Construct an Object instance.

Parameters

  [in] | parent | The object parent

The new Object instance is bound to the thread of its parent, or to the current thread if the parent is nullptr.

## ◆ ~Object()

libcamera::Object::~Object | ( |  | ) |
| virtual

Destroy an Object instance.

Deleting an Object automatically disconnects all signals from the Object's slots. All the Object's children are made orphan, but stay bound to their current thread.

Object instances shall be destroyed from the thread they are bound to, otherwise undefined behaviour may occur. If deletion of an Object needs to be scheduled from a different thread, deleteLater() shall be used.

As an exception to this rule, Object instances may be deleted from a different thread if the thread the instance is bound to is stopped through the whole duration of the object's destruction, and the parent and children of the object do not get deleted concurrently. The caller is responsible for fulfilling those requirements.

In all cases Object instances shall be deleted before the Thread they are bound to.

## Member Function Documentation

## ◆ assertThreadBound()

bool libcamera::Object::assertThreadBound | ( | const char * | message | ) |
| protected

Check if the caller complies with thread-bound constraints.

Parameters

  [in] | message | The message to be printed on error

This function verifies the calling constraints required by the thread-bound definition. It shall be called at the beginning of member functions of an Object subclass that are explicitly marked as thread-bound in their documentation.

If the thread-bound constraints are not met, the function prints message as an error message. For debug builds, it additionally causes an assertion error.

Todo
  Verify the thread-bound requirements for functions marked as thread-bound at the class level.

Returns
  True if the call is thread-bound compliant, false otherwise

## ◆ deleteLater()

void libcamera::Object::deleteLater | ( |  | ) |

Schedule deletion of the instance in the thread it belongs to.

This function schedules deletion of the Object when control returns to the event loop that the object belongs to. This ensures the object is destroyed from the right context, as required by the libcamera threading model.

If this function is called before the thread's event loop is started or after it has stopped, the object will be deleted when the event loop (re)starts. If this never occurs, the object will be leaked.

Deferred deletion can be used to control the destruction context with shared pointers. An object managed with shared pointers is deleted when the last reference is destroyed, which makes difficult to ensure through software design which context the deletion will take place in. With a custom deleter for the shared pointer using deleteLater(), the deletion can be guaranteed to happen in the thread the object is bound to.

std::shared_ptr<MyObject> createObject()
{
struct Deleter : std::default_delete<MyObject> {
void operator()(MyObject *obj)
{
obj->deleteLater();
}
};
MyObject *obj = new MyObject();
return std::shared_ptr<MyObject>(obj, Deleter());
}

Thread Safety
  This function is thread-safe.

## ◆ invokeMethod()

template<typename T, typename R, typename... FuncArgs, typename... Args, std::enable_if_t< std::is_base_of< Object, T >::value > * = nullptr>

R libcamera::Object::invokeMethod | ( | R(T::* | func )(FuncArgs...),
|  | ConnectionType | type,
|  | Args &&... | args )
| inline

Invoke a method asynchronously on an Object instance.

Parameters

  [in] | func | The object method to invoke
  [in] | type | Connection type for method invocation
  [in] | args | The method arguments

This function invokes the member method func with arguments args, based on the connection type. Depending on the type, the method will be called synchronously in the same thread or asynchronously in the object's thread.

Arguments args passed by value or reference are copied, while pointers are passed untouched. The caller shall ensure that any pointer argument remains valid until the method is invoked.

Due to the asynchronous nature of threads, functions invoked asynchronously with the ConnectionTypeQueued type are not guaranteed to be called before the thread is stopped. See Stopping Threads for additional information.

Thread Safety
  This function is thread-safe.

Returns
  For connection types ConnectionTypeDirect and ConnectionTypeBlocking, return the return value of the invoked method. For connection type ConnectionTypeQueued, return a default-constructed R value.

## ◆ message()

void libcamera::Object::message | ( | Message * | msg | ) |
| protectedvirtual

Message handler for the object.

Parameters

  [in] | msg | The message

This virtual function receives messages for the object. It is called in the context of the object's thread, and can be overridden to process custom messages. The parent Object::message() function shall be called for any message not handled by the override function.

The message msg is valid only for the duration of the call, no reference to it shall be kept after this function returns.

Reimplemented in libcamera::EventNotifier, and libcamera::Timer.

## ◆ moveToThread()

void libcamera::Object::moveToThread | ( | Thread * | thread | ) |

Move the object and all its children to a different thread.

Parameters

  [in] | thread | The target thread

This function moves the object and all its children from the current thread to the new thread.

Before the object is moved, a Message::ThreadMoveMessage message is sent to it. The message() function can be reimplement in derived classes to be notified of the upcoming thread move and perform any required processing.

Moving an object that has a parent is not allowed, and causes undefined behaviour.

Thread Safety
  This function is thread-bound.

## ◆ parent()

Object * libcamera::Object::parent | ( |  | ) | const
| inline

Retrieve the object's parent.

Returns
  The object's parent

## ◆ postMessage()

void libcamera::Object::postMessage | ( | std::unique_ptr< Message > | msg | ) |

Post a message to the object's thread.

Parameters

  [in] | msg | The message

This function posts the message msg to the message queue of the object's thread, to be delivered to the object through the message() function in the context of its thread. Message ownership is passed to the thread, and the message will be deleted after being delivered.

Messages are delivered through the thread's event loop. If the thread is not running its event loop the message will not be delivered until the event loop gets started.

Due to their asynchronous nature, threads do not provide any guarantee that all posted messages are delivered before the thread is stopped. See Stopping Threads for additional information.

Thread Safety
  This function is thread-safe.

## ◆ thread()

Thread * libcamera::Object::thread | ( |  | ) | const
| inline

Retrieve the thread the object is bound to.

Thread Safety
  This function is thread-safe.

Returns
  The thread the object is bound to

The documentation for this class was generated from the following files:

- include/libcamera/base/object.h
- src/libcamera/base/object.cpp